<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.6.0_25) on Mon Mar 28 17:40:56 CEST 2016 -->
<TITLE>
AuthenticationService
</TITLE>

<META NAME="date" CONTENT="2016-03-28">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="AuthenticationService";
    }
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">
<HR>


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;PREV CLASS&nbsp;
&nbsp;<A HREF="../../../../it/faac/assessment/service/BadAuthenticationException.html" title="class in it.faac.assessment.service"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?it/faac/assessment/service/AuthenticationService.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="AuthenticationService.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
it.faac.assessment.service</FONT>
<BR>
Class AuthenticationService</H2>
<PRE>
java.lang.Object
  <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><B>it.faac.assessment.service.AuthenticationService</B>
</PRE>
<HR>
<DL>
<DT><PRE><FONT SIZE="-1">@Service
</FONT>public class <B>AuthenticationService</B><DT>extends java.lang.Object</DL>
</PRE>

<P>
This service is responsible for user authentication and managing of logged users.
 <br />
 After a successfull login the user will be registered in the system with a unique token assigned.
 <br />
 The tokens grant access to the system for a <A HREF="../../../../it/faac/assessment/service/AuthenticationService.html#tokenExpirationTimeInMinutes"><CODE>tokenExpirationTimeInMinutes</CODE></A> minutes (this value can be configured
 with dependency injection), use the method <A HREF="../../../../it/faac/assessment/service/AuthenticationService.html#checkToken(java.lang.String)"><CODE>checkToken(String)</CODE></A> to verify token validity.
 <br />
 Please note what <strong>a user can have multiple active authentication</strong> at the same time, each
 one will be registered with a different token.
<P>

<P>
<HR>

<P>

<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../it/faac/assessment/service/AuthenticationService.html#AuthenticationService()">AuthenticationService</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../it/faac/assessment/service/AuthenticationService.html#checkToken(java.lang.String)">checkToken</A></B>(java.lang.String&nbsp;token)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;verify that a token is registered in the system and not expired</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../it/faac/assessment/service/AuthenticationService.html#cleanExpiredToken()">cleanExpiredToken</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;removes any <A HREF="../../../../it/faac/assessment/model/LoggedUser.html" title="class in it.faac.assessment.model"><CODE>LoggedUser</CODE></A> with an expired token, useful to be invoked by a scheduled job</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.util.Collection&lt;<A HREF="../../../../it/faac/assessment/model/LoggedUser.html" title="class in it.faac.assessment.model">LoggedUser</A>&gt;</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../it/faac/assessment/service/AuthenticationService.html#getLoggedUsers()">getLoggedUsers</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;<A HREF="../../../../it/faac/assessment/model/AuthenticatedUser.html" title="class in it.faac.assessment.model">AuthenticatedUser</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../it/faac/assessment/service/AuthenticationService.html#login(java.lang.String, java.lang.String)">login</A></B>(java.lang.String&nbsp;username,
      java.lang.String&nbsp;password)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;This method is responsible for user authentication, if username and password are
 registered in the system the method will return an <A HREF="../../../../it/faac/assessment/model/AuthenticatedUser.html" title="class in it.faac.assessment.model"><CODE>AuthenticatedUser</CODE></A>
 <br />
 If the user is not present or the password doesn't match a BadAuthenticationException
 will be throw.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.Object</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="AuthenticationService()"><!-- --></A><H3>
AuthenticationService</H3>
<PRE>
public <B>AuthenticationService</B>()</PRE>
<DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="login(java.lang.String, java.lang.String)"><!-- --></A><H3>
login</H3>
<PRE>
<FONT SIZE="-1">@Transactional(readOnly=false)
</FONT>public <A HREF="../../../../it/faac/assessment/model/AuthenticatedUser.html" title="class in it.faac.assessment.model">AuthenticatedUser</A> <B>login</B>(java.lang.String&nbsp;username,
                                             java.lang.String&nbsp;password)
                        throws <A HREF="../../../../it/faac/assessment/service/BadAuthenticationException.html" title="class in it.faac.assessment.service">BadAuthenticationException</A></PRE>
<DL>
<DD>This method is responsible for user authentication, if username and password are
 registered in the system the method will return an <A HREF="../../../../it/faac/assessment/model/AuthenticatedUser.html" title="class in it.faac.assessment.model"><CODE>AuthenticatedUser</CODE></A>
 <br />
 If the user is not present or the password doesn't match a BadAuthenticationException
 will be throw.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>username</CODE> - the username of the user<DD><CODE>password</CODE> - the user password
<DT><B>Returns:</B><DD>an instance of <A HREF="../../../../it/faac/assessment/model/AuthenticatedUser.html" title="class in it.faac.assessment.model"><CODE>AuthenticatedUser</CODE></A>
<DT><B>Throws:</B>
<DD><CODE><A HREF="../../../../it/faac/assessment/service/BadAuthenticationException.html" title="class in it.faac.assessment.service">BadAuthenticationException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="checkToken(java.lang.String)"><!-- --></A><H3>
checkToken</H3>
<PRE>
public void <B>checkToken</B>(java.lang.String&nbsp;token)
                throws <A HREF="../../../../it/faac/assessment/service/InvalidTokenException.html" title="class in it.faac.assessment.service">InvalidTokenException</A></PRE>
<DL>
<DD>verify that a token is registered in the system and not expired
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>token</CODE> - a token obtained after a <A HREF="../../../../it/faac/assessment/service/AuthenticationService.html#login(java.lang.String, java.lang.String)"><CODE>login(String, String)</CODE></A>
<DT><B>Throws:</B>
<DD><CODE><A HREF="../../../../it/faac/assessment/service/InvalidTokenException.html" title="class in it.faac.assessment.service">InvalidTokenException</A></CODE></DL>
</DD>
</DL>
<HR>

<A NAME="getLoggedUsers()"><!-- --></A><H3>
getLoggedUsers</H3>
<PRE>
public java.util.Collection&lt;<A HREF="../../../../it/faac/assessment/model/LoggedUser.html" title="class in it.faac.assessment.model">LoggedUser</A>&gt; <B>getLoggedUsers</B>()</PRE>
<DL>
<DD><DL>

<DT><B>Returns:</B><DD>a collection of <A HREF="../../../../it/faac/assessment/model/LoggedUser.html" title="class in it.faac.assessment.model"><CODE>LoggedUser</CODE></A>, each one representing a user currently
 logged into the system, user with an expired token will NOT be included</DL>
</DD>
</DL>
<HR>

<A NAME="cleanExpiredToken()"><!-- --></A><H3>
cleanExpiredToken</H3>
<PRE>
<FONT SIZE="-1">@Transactional(readOnly=false)
</FONT>public void <B>cleanExpiredToken</B>()</PRE>
<DL>
<DD>removes any <A HREF="../../../../it/faac/assessment/model/LoggedUser.html" title="class in it.faac.assessment.model"><CODE>LoggedUser</CODE></A> with an expired token, useful to be invoked by a scheduled job
<P>
<DD><DL>
</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-files/index-1.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;PREV CLASS&nbsp;
&nbsp;<A HREF="../../../../it/faac/assessment/service/BadAuthenticationException.html" title="class in it.faac.assessment.service"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?it/faac/assessment/service/AuthenticationService.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="AuthenticationService.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
